<?php

    add_action('main_page_admin', 'import_vkontakte_page');
    add_action('main_page_admin', 'import_vkontakte_clear_page');

    function import_vkontakte_install()
    {

        //  add_option('vk_merchant_id', 'id вашего магазина');
        //  add_option('vk_secret_key', 'ваш защищенный ключ магазина');  
        add_option('vk_merchant_id', '');
        add_option('vk_secret_key', '');
        add_option('vk_test_mode', 'true','radio', 'array("true","false")');
        add_option('vkontakte', '', 'readonly');
    }

    //страница удаления товаров
    function import_vkontakte_clear_page()
    {
        //method=catalog.clear
        $test_mode = get_option('vk_test_mode');

        if ( $test_mode == 'true') $test_mode = 1; 
        else $test_mode = 0;

        $params = array(
        'merchant_id' => get_option('vk_merchant_id'),
        'timestamp'   => time(),
        'test_mode'   => $test_mode,
        'method'      => 'catalog.clear',
        'random'      => mt_rand(0, 1000000)
        );


        function s($val) 
        {
            return $val;
        }


        ksort($params);
        $params_sig = '';
        $params_pairs = array();
        foreach ($params as $k => $v) {
            $params_sig .= $k.'='.$v;
            $params_pairs[] = $k.'='.urlencode($v);
        }
        $params_sig .= get_option('vk_secret_key');
        $params_pairs[] = 'sig='.md5($params_sig);
        $params_str = implode('&', $params_pairs);
        $output = array();
        $rc = 0;

        $request_url = 'http://api.vkontakte.ru/merchant.php';

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $request_url);
        curl_setopt($ch, CURLOPT_FAILONERROR, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 15);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $params_str);
        $result = curl_exec($ch); // run the whole process
        $rc = curl_errno($ch);

        if ($rc) 
        {
            echo 'Код ошибки: '.$rc.', ошибка: '.curl_error($ch).'<br>';
        }

        curl_close($ch);

        echo 'Результат:<br>';
        $error = simplexml_load_string($result);

        if ( !empty($error->error_code) )
        {
            echo ('<b>Код ошибки:</b> '.$error->error_code.'<br>');
            echo ('<b>Ошибка:</b> '.$error->error_msg.'<br>');
        }
        else
        {
            echo '<b>Успешно</b>';
        }
    }

    function import_vkontakte_page()
    {
        global $osPrice;
        include( dir_path('catalog').'includes/classes/price.php');
        $osPrice = new osPrice($_SESSION['currency'], $_SESSION['customers_status']['customers_status_id']);
        $test_mode = get_option('vk_test_mode');

        if ( $test_mode == 'true') $test_mode = 1; 
        else $test_mode = 0;

        $params = array(
        'merchant_id' => get_option('vk_merchant_id'),
        'timestamp'   => time(),
        'test_mode'   => $test_mode,
        'method'      => 'catalog.changeItems',
        'random'      => mt_rand(0, 1000000)
        );

        $params['method'] = 'catalog.changeItems';

        $_params    = $params;

        $products_sql = "SELECT distinct p.products_id, p2c.categories_id, products_short_description, p.products_model,cd.categories_name, p.products_quantity, p.products_image, IF(s.status, s.specials_new_products_price, p.products_price) AS products_price, p.products_tax_class_id, p.manufacturers_id, p.products_sort, GREATEST(p.products_date_added, IFNULL(p.products_last_modified, 0), IFNULL(p.products_date_available, 0)) AS base_date, pd.products_name, m.manufacturers_name, pd.products_description" .
        (($products_short_description > 0) ? ", pd.products_short_description " : " ") . "as proddesc " .
        (($yml_select > 0) ? ", p.yml_bid, p.yml_cbid " : "") .
        "FROM " . TABLE_PRODUCTS . " p
        LEFT JOIN " . TABLE_PRODUCTS_DESCRIPTION . " pd ON (p.products_id = pd.products_id)
        LEFT JOIN " . TABLE_MANUFACTURERS . " m ON (p.manufacturers_id = m.manufacturers_id)
        LEFT JOIN " . TABLE_PRODUCTS_TO_CATEGORIES . " p2c ON (p.products_id = p2c.products_id)
        LEFT JOIN " . DB_PREFIX . "categories_description cd ON (p2c.categories_id = cd.categories_id)
        LEFT JOIN " . TABLE_SPECIALS . " s ON (p.products_id = s.products_id)
        WHERE p.products_status = 1" .
        (($yml_select > 0) ? " and p.products_to_xml = 1" : "") .
        " AND pd.language_id = " . (int)$_SESSION['languages_id'] . "
        GROUP BY p.products_id  ORDER BY p.products_id ASC";

        $products_query = os_db_query($products_sql);
        $i = 0;
        $a = 0;

        $current_currency = $_SESSION['currency'];
        if($_SESSION['currency'] == 'RUR') $current_currency = 'RUB';

        $query_array = array();
        $params =  $_params;
        while ($p = os_db_fetch_array($products_query)) 
        {

            $params['item_id_'.$i] = $p['products_id'];
            $params['item_name_'.$i] = $p['products_name'];

            if ( !empty($p['products_description']))
            {
                $params['item_description_'.$i] = $p['products_description'];
            }
            else
            {
                $params['item_description_'.$i] = 'нет описания';

            }

            if ( !empty($p['products_short_description']))
            {
                $params['item_short_description_'.$i] = $p['products_short_description'];
            }
            else
            {
                $params['item_short_description_'.$i] = 'нет описания';

            }


            $params['item_currency_'.$i] = $current_currency;

            $price = $p['products_price'];
            $price = $osPrice->GetPrice($p['products_id'], $format = false, 1, $p['products_tax_class_id'], $price);

            $params['item_price_'.$i] = $price;
            $params['item_photo_url_'.$i.'_1'] = http_path('images_info') . $p['products_image'];
            $params['item_category_'.$i] = $p['categories_name'];
            $params['item_unavailable_'.$i] = 0;
            $params['item_digital_'.$i] = 0;

            $a++;
            if ($a >= 15)
            {   
                $query_array[] = $params;
                $params = $_params;
                $a = 0;
                $i = 0;
            }

            $i++;
        }

        if ( count($params) > 0 )
        {
            $query_array[] = $params;
        }

        foreach ($query_array as $num => $__params)
        {
            $params = $__params; 

            $result= '';
            $ch = '';
            $rc = '';
            $error ='';
            $params_str = '';
            ksort($params);
            $params_sig = '';
            $params_pairs = array();
            foreach ($params as $k => $v) {
                $params_sig .= $k.'='.$v;
                $params_pairs[] = $k.'='.urlencode($v);
            }
            $params_sig .= get_option('vk_secret_key');
            $params_pairs[] = 'sig='.md5($params_sig);
            $params_str = implode('&', $params_pairs);
            $output = array();
            $rc = 0;

            $request_url = 'http://api.vkontakte.ru/merchant.php';

            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $request_url);
            curl_setopt($ch, CURLOPT_FAILONERROR, 1);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_TIMEOUT, 15);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $params_str);
            $result = curl_exec($ch); // run the whole process

            $rc = curl_errno($ch);

            if ($rc) 
            {
                echo 'Код ошибки: '.$rc.', ошибка: '.curl_error($ch).'<br>';
            }
            curl_close($ch);

            echo 'Результат '.($num+1).':<br>';

            //  print_r($result);
            $error = @ simplexml_load_string($result);

            if ( !empty($error->error_code) )
            {
                echo ('<b>Код ошибки:</b> '.$error->error_code.'<br>');
                echo ('<b>Ошибка:</b> '.$error->error_msg.'<br>');
            }
            else
            {
                echo '<b>Успешно импортировано</b> '. ((count($params) - 5) /10 ).' товаров.<br>';
            } 
        }

    }

    function vkontakte_readonly()
    {
        _e('<center>'.add_button('main_page', 'import_vkontakte_page', 'Импорт товаров Вконтакте' ).'</center>');
        _e('<center>'.add_button('main_page', 'import_vkontakte_clear_page', 'Очистить каталог Вконтакте' ).'</center>');

    }

?>